/**
	$Id$

	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.plugins;

import net.sf.basedb.core.BioMaterialEvent;
import net.sf.basedb.core.BioMaterialEventSource;
import net.sf.basedb.core.DbControl;
import net.sf.basedb.core.MeasuredBioMaterial;
import net.sf.basedb.core.SpecialQuery;

/**	
	This is a loader implementation that load information about all source biomaterial
	for a given child biomaterial.
	
	@author Nicklas
	@since 3.1
	@base.modified $Date$
*/

public class ParentBioMaterialEventSourceLoader 
	implements DataLoader<MeasuredBioMaterial>
{

	private final SpecialQuery<BioMaterialEventSource> query;
	
	public ParentBioMaterialEventSourceLoader()
	{
		this.query = BioMaterialEventSource.getQuery((BioMaterialEvent)null);
	}
	
	@Override
	public Object getData(DbControl dc, ExportedProperty exportedProperty, MeasuredBioMaterial item) 
		throws Exception
	{
		Object parents = null;
		if (item.getParentType() == null)
		{
			// No parents
		}
		else
		{
			query.setEntityParameter("event", item.getCreationEvent());
			parents = query.list(dc);
		}
		return parents;
	}

}
