/**
	$Id: AnnotationInfo.java 6434 2014-03-14 08:30:20Z nicklas $

	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.info;

import java.io.Serializable;


/**
  	An information class that holds information about annotation values
  	for a given annotation type.
  	@author Nicklas
  	@version 2.5 	
 	@deprecated In 3.3, no replacement
 */
@Deprecated
public class AnnotationInfo
	implements Serializable, Transferable
{

	private static final long serialVersionUID = 1098477223071956298L;
	private int annotationTypeId;
	private String valueType;
	private String[] values;
	
	/**
	 	Creates information object with 
	 	no properties set.
	*/
	public AnnotationInfo()
	{
		super();
	}

	/**
	 	@return Returns the annotation values as strings
	*/
	public String[] getValues()
	{
		return values;
	}

	/**
		@param values Change the annotation values
	*/
	public void setValues(String[] values)
	{
		this.values = values;
	}

	/**
		@return The external ID of the annotation type or null
	*/
	public int getAnnotationTypeId()
	{
		return annotationTypeId;
	}

	/**
		@param annotationTypeId The annotationTypeId to set
	*/
	public void setAnnotationTypeId(int annotationTypeId)
	{
		this.annotationTypeId = annotationTypeId;
	}

	/**
		@return The class of values that can be used for annotations. The value
			is the string representation of one of the options in {@link net.sf.basedb.core.Type},
			ie. STRING, INT, LONG
	*/
	public String getValueType()
	{
		return valueType;
	}

	/**
	 	@param valueType The class of values that can be used for annotations.
	 	@see #getValueType()
	*/
	public void setValueType(String valueType)
	{
		this.valueType = valueType;
	}


}
