/**
	$Id: AnnotationTypeClient.java 6435 2014-03-17 08:01:38Z nicklas $

	Copyright (C) 2007 Martin Svensson, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.ws.client;


import org.apache.axis2.AxisFault;

/**
 	Web service client for annotation types.
 	Calls services in {@link net.sf.basedb.ws.server.AnnotationTypeService}
  	@author Nicklas
  	@version 2.5
 	@deprecated In 3.3, no replacement
 */
@Deprecated
public class AnnotationTypeClient 
	extends AbstractRPCClient 
{
	private final SessionClient session;
	
	/**
	 	Creates new AnnotationTypeClient object for an active session client.
	  	@param session The active session client
	 */
	public AnnotationTypeClient(SessionClient session)
	{
		super(session.getUrl(), "AnnotationType", session.getServiceFactory());
		this.session = session;
	}
	
	/**
		Get info about an annotation type when you know the ID.
		@param itemId The ID of the annotation type
		@return An AnnotationTypeInfo object
	  	@throws AxisFault If communication with web service fails.
	*/
	public net.sf.basedb.info.AnnotationTypeInfo getById(int itemId)
		throws AxisFault
	{
		return invokeBlocking("getById", net.sf.basedb.info.AnnotationTypeInfo.class, 
			session.getId(), itemId);
	}
	/**
	 	Gets info about each projects that are available for the active session client.
	 	@param itemType The name of the item type as defined by {@link net.sf.basedb.core.Item#name()}
	 		or null to return annotation types for all item types
	  	@param qOpt Options to put on the query 
	  	@return An array with a info object for each annotation type
	  	@throws AxisFault If communication with web service fails.
	 */
	public net.sf.basedb.info.AnnotationTypeInfo[] getAnnotationTypes(String itemType, net.sf.basedb.info.QueryOptions qOpt)
		throws AxisFault
	{		 
		net.sf.basedb.info.AnnotationTypeInfo[] result = invokeBlocking("getAnnotationTypes", net.sf.basedb.info.AnnotationTypeInfo[].class, 
			session.getId(), itemType, qOpt);
		return result;
	}
}
