/**
	$Id: ExperimentClient.java 6435 2014-03-17 08:01:38Z nicklas $

	Copyright (C) 2007 Martin Svensson, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.ws.client;


import org.apache.axis2.AxisFault;

/**
 	Webservice client for Experiment.
 	Call services in {@link net.sf.basedb.ws.server.ExperimentService}
  	@author Martin
  	@version 2.5
 	@deprecated In 3.3, no replacement
 */
@Deprecated
public class ExperimentClient 
	extends AbstractRPCClient 
{	
	private final SessionClient session;
	
	/**
	 	Creates a new client in active session
	  	@param session The active session
	 */
	public ExperimentClient(SessionClient session)
	{
		super(session.getUrl(), "Experiment", session.getServiceFactory());
		this.session = session;
	}
	
	/**
		Get info about an experiment when you know the ID.
		@param itemId The ID of the experiment
		@return An ExperimentInfo object
		@throws AxisFault If communication with web service fails.
	*/
	public net.sf.basedb.info.ExperimentInfo getById(int itemId)
		throws AxisFault
	{
		return invokeBlocking("getById", net.sf.basedb.info.ExperimentInfo.class, 
			session.getId(), itemId);
	}
	
	/**
	 	Gets info about experiments that are available in the logged in session.
	  	@param qOpt Options to put on the query that gets the experiments.
	  	@return An array with info object for each experiment that was found. 
	  	@throws AxisFault If communication with web service fails.
	 */
	public net.sf.basedb.info.ExperimentInfo[] getExperiments(net.sf.basedb.info.QueryOptions qOpt)
		throws AxisFault
	{
		net.sf.basedb.info.ExperimentInfo[] result = invokeBlocking("getExperiments", net.sf.basedb.info.ExperimentInfo[].class, session.getId(), qOpt);
		return result;
	}
	
	/**
		Gets info about raw bioassays used in an experiment.		
	  	@param experimentId Id of experiment to get raw bioassays from.
	  	@param qOpt Options to put on the query that gets the raw bioassays.
	  	@return An array with info object about each raw bioassay that was found.
	  	@throws AxisFault If communication with web services fails.
	 */
	public net.sf.basedb.info.RawBioAssayInfo[] getRawBioAssays(int experimentId, net.sf.basedb.info.QueryOptions qOpt)
		throws AxisFault
	{
		net.sf.basedb.info.RawBioAssayInfo[] result = invokeBlocking("getRawBioAssays", net.sf.basedb.info.RawBioAssayInfo[].class, session.getId(), experimentId, qOpt);
		return result;
	}
	
	/**
	 	Gets info about bioassay sets in an experiment
	  	@param experimentId Id of the experiment to get the bioassay sets from
	  	@param qOpt Options to put on the query that gets the bioassay sets.
	  	@return An array with info about each bioassay set found by the query.
	  	@throws AxisFault If communication with web services fails.
	 */
	public net.sf.basedb.info.BioAssaySetInfo[] getBioAssaySets(int experimentId, net.sf.basedb.info.QueryOptions qOpt)
		throws AxisFault
	{
		net.sf.basedb.info.BioAssaySetInfo[] result = invokeBlocking("getBioAssaySets", net.sf.basedb.info.BioAssaySetInfo[].class, session.getId(), experimentId, qOpt);
		return result;
	}


	/**
		Gets info about the experimental factors for an experiment.
	  	@param experimentId Id of experiment to get experimental factors from
	  	@param qOpt Options to put on the query
	  	@return An array with info object about each annotation type that was found
	  	@throws AxisFault If communication with web services fails.
	*/
	public net.sf.basedb.info.AnnotationTypeInfo[] getExperimentalFactors(int experimentId, net.sf.basedb.info.QueryOptions qOpt)
		throws AxisFault
	{
		net.sf.basedb.info.AnnotationTypeInfo[] result = invokeBlocking("getExperimentalFactors", net.sf.basedb.info.AnnotationTypeInfo[].class, session.getId(), experimentId, qOpt);
		return result;
	}

	
	/**
	 	Gets info about reporter lists in an experiment.
	  	@param experimentId Id of the experiment the lists are used in
	  	@param qOpt Options to put on the query that gets the reporter lists.
	  	@return An array with info about each reporter list.
	  	@throws AxisFault If communication with web services fails.
	 */
	public net.sf.basedb.info.ReporterListInfo[] getReporterLists(int experimentId, net.sf.basedb.info.QueryOptions qOpt)
		throws AxisFault
	{
		net.sf.basedb.info.ReporterListInfo[] result = invokeBlocking("getReporterLists", net.sf.basedb.info.ReporterListInfo[].class, session.getId(), experimentId, qOpt);
		return result;
	}
}
