/**
	$Id $

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.ws.client;

import java.io.IOException;
import java.io.InputStream;


import org.apache.axis2.AxisFault;
import org.apache.axis2.Constants;
import org.apache.axis2.client.Options;
import org.apache.axis2.rpc.client.RPCServiceClient;

/**
 	Web service client for files in BASE.
 	Calls services in {@link net.sf.basedb.ws.server.FileService}
  	@author Nicklas
  	@since 3.0
 	@deprecated In 3.3, no replacement
 */
@Deprecated
public class FileClient 
	extends AbstractRPCClient 
{
	private final SessionClient session;
	
	/**
	 	Creates new ProjectClient object for an active session client.
	  	@param session The active session client
	 */
	public FileClient(SessionClient session)
	{
		super(session.getUrl(), "File", session.getServiceFactory());
		this.session = session;
	}
	
	/**
		Get info about a file when you know the ID.
		@param itemId The ID of the file
		@return An FileInfo object
		@throws AxisFault If communication with web service fails.
	*/
	public net.sf.basedb.info.FileInfo getById(int itemId)
		throws AxisFault
	{
		return invokeBlocking("getById", net.sf.basedb.info.FileInfo.class, 
			session.getId(), itemId);
	}

	
	/**
	 	Download a file when you know the id.
	  	@param fileId Id of file to download
	  	@return An InputStream to read the file data from, or null
	  		if the file has no data
	  	@throws AxisFault If communication with webservices fails.
	  	@throws IOException If writing to the target file fails.
	*/
	public InputStream download(int fileId) 
		throws AxisFault, IOException
	{
		RPCServiceClient service = getService();
		Options options = service.getOptions();		
		options.setProperty(Constants.Configuration.ENABLE_MTOM, Constants.VALUE_TRUE);
		service.setOptions(options);
		return invokeFileBlocking
			(
				"download", 
				session.getId(), 
				fileId
			);
	}
}
