/**
	$Id $

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.ws.server;

import org.apache.axiom.om.OMElement;

import net.sf.basedb.core.DbControl;
import net.sf.basedb.core.File;
import net.sf.basedb.core.SessionControl;


/**
 	Web service class for File
 	{@link net.sf.basedb.core.File}.
  	@author Nicklas
  	@since 3.0
 	@deprecated In 3.3, no replacement
 */
@Deprecated
public class FileService
	extends AbstractRPCService
{
	/**
	 	
	 */
	public FileService()
	{}
	
	/**
		Get information about a file that you know the ID of.
		@param ID Id to identify the session.
		@param itemId The ID of the file
		@return The file information
	*/
	public net.sf.basedb.info.FileInfo getById(String ID, int itemId)
	{
		SessionControl sc = getSessionControl(ID);
		DbControl dc = sc.newDbControl();	
		try
		{
			File f = File.getById(dc, itemId);
			return f.toTransferable(new net.sf.basedb.info.FileInfo());
		}
		finally
		{
			if (dc != null) dc.close();
		}
	}
	
	/**
		Download the file contents.
	 	
	  	@param ID Used to identify an active session with.
	  	@param fileId Id of the file to download
	  	@return OMElement with the file attached, 
	  		or NULL if no file was found or doesn't have any
	  		data
	*/
	public OMElement download(String ID, int fileId)
	{
		SessionControl sc = getSessionControl(ID);
		DbControl dc = sc.newDbControl();
		OMElement toDownload = null;
		try
		{
			File f = File.getById(dc, fileId);
			if (f.getLocation().isDownloadable())
			{
				BaseFileDataSource source = new BaseFileDataSource(f);
				toDownload = attachFile(source, "downloadFile");
			}
		}
		finally
		{
			if (dc != null) dc.close();
		}		
		return toDownload;
	}

}
