/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var AddMembers = function()
{
	var addMembers = {};
	
	/**
		Initialize the page.
	*/
	addMembers.initPage = function()
	{
		
		Buttons.addClickHandler('btnAddSelected', addMembers.addSelected);
		Buttons.addClickHandler('btnAddPage', addMembers.addCurrentPage);
		Buttons.addClickHandler('btnAddAll', addMembers.addAll);
		
		Buttons.addClickHandler('close', App.closeWindow);
	}
	
	addMembers.addSelected = function(event)
	{
		var tableId = Data.get(event.currentTarget, 'table-id');
		var selected = top['members'].Table.getSelected(tableId);
		if (selected.length == 0)
		{
			Forms.showNotification('check.uncheck', 'Please select at least one item in the list', null, 'pointer-left');
			return;
		}
		var frm = document.forms['addMembers'];
		frm.which.value = 'selected';
		Forms.addHidden(frm, 'items', selected.join(','));
		frm.submit();
	}

	
	addMembers.addCurrentPage = function()
	{
		var frm = document.forms['addMembers'];
		frm.which.value = 'page';
		frm.submit();
	}

	addMembers.addAll = function()
	{
		var frm = document.forms['addMembers'];
		frm.which.value = 'all';
		frm.submit();
	}

	
	return addMembers;
}();

Doc.onLoad(AddMembers.initPage);
