<%-- $Id: list_wells.jsp 6482 2014-06-13 12:11:12Z olle $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.Well"
	import="net.sf.basedb.core.ReporterType"
	import="net.sf.basedb.core.Reporter"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.ArrayList"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.WELL;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final int plateId = Values.getInt(request.getParameter("plate_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("well", "wells");
final DbControl dc = sc.newDbControl();
ItemResultIterator<Well> wells = null;
ItemResultList<AnnotationType> annotationTypes = null;
try
{
	final ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(itemType);
	annotationTypes = annotationTypeQuery.list(dc);
	final Plate plate = Plate.getById(dc, plateId);
	final boolean createPermission = plate.hasPermission(Permission.WRITE);
	final boolean deletePermission = createPermission;

	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	final ItemQuery<ReporterType> typeQuery = ReporterType.getQuery();
	typeQuery.order(Orders.asc(Hql.property("name")));
	typeQuery.setCacheResult(true);
	List<ExtendedProperty> reporterProperties = ExtendedProperties.getProperties("ReporterData");
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	
	Enumeration<String,String> rows = new Enumeration<String, String>();
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	for (int i=0; i<plate.getPlateType().getPlateGeometry().getRows() && i < 256; i++)
	{
		rows.add(Integer.toString(i), rowFormatter.format(i));
	}
	
	Enumeration<String,String> columns = new Enumeration<String, String>();
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);
	for (int i=0; i<plate.getPlateType().getPlateGeometry().getColumns() && i < 256; i++)
	{
		columns.add(Integer.toString(i), columnFormatter.format(i));
	}
	
	try
	{
		final ItemQuery<Well> query = Base.getConfiguredQuery(dc, cc, true, plate.getWells(), mode);
		query.join(Hql.leftJoin(null, "reporter", "rpt", null, true));
		if (!"row".equals(cc.getSortProperty())) query.order(Orders.asc(Hql.property("row")));
		if (!"column".equals(cc.getSortProperty())) query.order(Orders.asc(Hql.property("column")));
		wells = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, plate);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" type="<%=mode.getPageType()%>" id="list-page">
	<base:head scripts="table.js,tabcontrol-2.js,~wells.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	
	<base:body>
		<p:path><p:pathelement 
			title="Plates" href="<%="../index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(plate.getName())%>" 
			/></p:path>

		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol"
			active="wells">
		<t:tab id="properties" title="Properties" />
		<t:tab id="annotations" title="Annotations" />
		<t:tab id="events" title="Events" />
		
		<t:tab id="wells" title="Wells">
		<tbl:table 
			id="wells" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subclass="fulltable"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="plate_id" 
				value="<%=String.valueOf(plateId)%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="row"
				property="row"
				datatype="int"
				title="Row"
				sortable="true" 
				filterable="true"
				exportable="true"
				enumeration="<%=rows%>"
				show="always"
				formatter="<%=new WellCoordinateFormatter(true)%>"  
			/>
			<tbl:columndef 
				id="column"
				property="column"
				datatype="int"
				title="Column"
				sortable="true" 
				filterable="true"
				exportable="true"
				enumeration="<%=columns%>"
				show="always" 
				formatter="<%=new WellCoordinateFormatter(false)%>" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="parent"
				title="Parent"
			/>
			<tbl:columndef
				id="reporterList"
				property="$rpt.£reporterListScores"
				datatype="int"
				title="[Rep] Reporter list"
				filterable="true"
				enumeration="<%=Base.getReporterListsEnum(dc)%>"
				multiple="false"
			/>
			<tbl:columndef 
				id="reporter.name"
				property="reporter.name"
				datatype="string"
				title="[Rep] Name"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="reporter.externalId"
				clazz="uniquecol"
				property="reporter.externalId"
				datatype="string"
				title="[Rep] ID"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="reporter.symbol"
				property="reporter.symbol"
				datatype="string"
				title="[Rep] Gene symbol"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="reporter.description"
				property="reporter.description"
				datatype="string"
				title="[Rep] Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef 
				id="reporter.entryDate"
				property="reporter.entryDate"
				datatype="date"
				title="[Rep] Registered"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="reporter.lastUpdate"
				property="reporter.lastUpdate"
				datatype="timestamp"
				title="[Rep] Last update" 
				sortable="true" 
				filterable="true" 
				exportable="true"
				formatter="<%=dateTimeFormatter%>"
			/>
			<%
			Enumeration<String, String> types = new Enumeration<String, String>();
			ItemResultList<ReporterType> reporterTypes = typeQuery.list(dc);
			types.add("", "- none -");
			for (ReporterType rt : reporterTypes)
			{
				types.add(Integer.toString(rt.getId()), HTML.encodeTags(rt.getName()));
			}
			%>
			<tbl:columndef 
				id="reporter.reporterType"
				property="reporter.reporterType"
				sortproperty="reporter.reporterType.name"
				exportproperty="reporter.reporterType.name:string"
				datatype="int"
				enumeration="<%=types%>"
				title="[Rep] Type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<%
			if (reporterProperties != null)
			{
				for (ExtendedProperty ep : reporterProperties)
				{
					String name = ep.getName();
					%>
					<tbl:columndef
						id="<%="reporter."+name%>"
						property="<%="reporter."+name%>"
						datatype="<%=ep.getType().getStringValue()%>"
						title="<%="[Rep] "+HTML.encodeTags(ep.getTitle())%>"
						sortable="true"
						filterable="true"
						exportable="true"
						formatter="<%=FormatterFactory.getExtendedPropertyFormatter(sc, ep)%>"
					/>
					<%
				}
			}
			%>
			<%
			for (AnnotationType at : annotationTypes)
			{
				Enumeration<String, String> annotationEnum = null;
				Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
				if (at.isEnumeration())
				{
					annotationEnum = new Enumeration<String, String>();
					List<?> values = at.getValues();
					for (Object value : values)
					{
						String encoded = formatter.format(value);
						annotationEnum.add(encoded, encoded);
					}
				}
				%>
				<tbl:columndef 
					id="<%="at"+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+" [A]"%>" 
					property="<%="#"+at.getId()%>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					smartenum="<%=at.getDisplayAsList() %>"
					sortable="<%=at.getMultiplicity() == 1%>" 
					filterable="true" 
					exportable="true"
					formatter="<%=formatter%>"
					unit="<%=at.getDefaultUnit()%>"
				/>
				<%
			}
			%>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bottomborder">
				<tbl:toolbar
					subclass="bottomborder"
					visible="<%=mode.hasToolbar()%>"
					>
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button
						id="btnNewReporterList"
						image="add.png"
						title="New reporter list&hellip;"
						tooltip="Create a new reporter list from matching wells"
						visible="<%=sc.hasPermission(Permission.CREATE, Item.REPORTERLIST)%>"
					/>
					<tbl:button 
						id="btnImport"
						data-plugin-type="IMPORT"
						image="import.png" 
						title="Import&hellip;" 
						tooltip="Import data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
					/>
					<tbl:button 
						id="btnExport"
						data-plugin-type="EXPORT"
						image="export.png" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
					<tbl:button 
						id="btnRunPlugin"
						data-plugin-type="OTHER"
						image="runplugin.png" 
						title="Run plugin&hellip;" 
						tooltip="Run a plugin" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector />
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=wells == null ? 0 : wells.getTotalCount()%>" 
						visible="<%=mode.hasNavigator()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header subclass="index" />
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasCheck()%>"
							><base:icon 
								id="check.uncheck"
								image="check_uncheck.png" 
								tooltip="Check/uncheck all" 
								 
							/></tbl:header>
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasRadio()%>"
							/>
						<tbl:header 
							subclass="icons" 
							visible="<%=mode.hasIcons()%>"
							/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (wells != null)
					{						
						while (wells.hasNext())
						{
							Well item = wells.next();
							int itemId = item.getId();
							boolean writePermission = item.hasPermission(Permission.WRITE);
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : ""); 
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
											type="checkbox" 
											name="<%=itemId%>" 
											value="<%=itemId%>" 
											title="TODO" 
											<%=cc.getSelected().contains(itemId) ? "checked" : ""%>
										></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
											type="radio" 
											name="item_id" 
											value="<%=itemId%>" 
											title="TODO" 
											<%=selectedItemId == itemId ? "checked" : ""%>
										></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									>&nbsp;</tbl:header>
								<tbl:cell column="row"><div 
									class="link table-item"
									data-item-id="<%=itemId%>"
									data-no-edit="<%=writePermission ? 0 : 1 %>"
									tabindex="0"
									title="<%=tooltip%>"><tbl:cellvalue value="<%=item.getRow()%>" /></div></tbl:cell>
								<tbl:cell column="column"><tbl:cellvalue value="<%=item.getColumn()%>"/></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="parent">
									<%
									try
									{
										Well parent = item.getParent();
										if (parent == null)
										{
											%>
											<i>- none -</i>
											<%
										}
										else
										{
											%>
											<%=Base.getLink(ID, 
												parent.getPlate().getName() + " [" + parent.getRow() + ", " + parent.getColumn() + "]", 
												Item.WELL, parent.getId(), true)%>
											<%
										}
									}
									catch (PermissionDeniedException ex)
									{
										%>
										<i>- denied -</i>
										<%
									}
									%>
								</tbl:cell>
								<%
								ReporterData reporter = item.getReporter();
								if (reporter == null)
								{
									%>
									<tbl:cell column="reporter.name"><i>- none -</i></tbl:cell>
									<tbl:cell column="reporter.externalId"><i>- none -</i></tbl:cell>
									<%
								}
								else
								{
									%>
									<tbl:cell column="reporter.name"><%=Base.getLink(ID, reporter.getName(), Item.REPORTER, reporter.getId(), true)%></tbl:cell>
									<tbl:cell column="reporter.externalId"><%=HTML.encodeTags(reporter.getExternalId())%></tbl:cell>
									<tbl:cell column="reporter.symbol"><%=HTML.encodeTags(reporter.getSymbol())%></tbl:cell>
									<tbl:cell column="reporter.description"><%=HTML.encodeTags(reporter.getDescription())%></tbl:cell>
									<tbl:cell column="reporter.entryDate" value="<%=reporter.getEntryDate()%>" />
									<tbl:cell column="reporter.lastUpdate" value="<%=reporter.getLastUpdate()%>" />
									<tbl:cell column="reporter.reporterType"
										><base:propertyvalue 
											dbcontrol="<%=dc%>" 
											item="<%=reporter%>" 
											property="reporterType"
											enableEditLink="<%=mode.hasEditLink()%>" 
											enablePropertyLink="<%=mode.hasPropertyLink()%>"
										/></tbl:cell>
									<%
									if (reporterProperties != null)
									{
										for (ExtendedProperty ep : reporterProperties)
										{
											String name = ep.getName();
											%>
											<tbl:cell column="<%="reporter."+name%>"><tbl:cellvalue value="<%=reporter.getExtended(name)%>" /></tbl:cell>
											<%
										}
									}
								}
								AnnotationSet as = item.isAnnotated() ? item.getAnnotationSet() : null;
								if (as != null)
								{
									for (AnnotationType at : annotationTypes)
									{
										if (as.hasAnnotation(at))
										{
											Annotation a = as.getAnnotation(at);
											String suffix = a.getUnitSymbol(null);
											if (suffix != null) suffix = "&nbsp;" + suffix;
											%>
											<tbl:cell 
												column="<%="at"+at.getId()%>"
												><tbl:cellvalue 
													list="<%=a.getValues(null)%>"
													suffix="<%=suffix%>"
											/></tbl:cell>
											<%
										}
									}
								}
								%>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
						}
					}
					if (numListed == 0)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer note">
							<%=wells == null || wells.getTotalCount() == 0 ? "No wells were found" : "No wells on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
		</tbl:table>
	
		</t:tab>
		<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>" />
		</t:tabcontrol>


		<base:buttongroup>
			<base:button id="btnOk" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button id="close" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button id="close" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
	
	</base:body>
	</base:page>
	<%
}
finally
{
	if (wells != null) wells.close();
	if (dc != null) dc.close();
}
%>
