<%-- $Id: index.jsp 6315 2013-09-06 11:55:09Z nicklas $
	------------------------------------------------------------------
	BioArray Software Environment (BASE) - http:// base.thep.lu.se/

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataProperty"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Restriction"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="java.util.List"
	import="java.util.LinkedList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private static void addFormulaOption(StringBuilder options, String formula, String title, String description)
{
	options.append("<option value=\"").append(HTML.encodeTags(formula)).append("\"");
	options.append(" title=\"").append(HTML.encodeTags(description)).append("\"");
	options.append(">").append(HTML.encodeTags(title)).append("\n");
}

%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final float scale = Base.getScale(sc);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
try
{
	int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"));
	int bioAssayId = Values.getInt(request.getParameter("bioassay_id"));
	BioAssay ba = bioAssayId == 0 ? null : BioAssay.getById(dc, bioAssayId);
	BioAssaySet bas = ba == null ? BioAssaySet.getById(dc, bioAssaySetId) : ba.getBioAssaySet();
	RawDataType rdt = bas.getRawDataType();
	Experiment experiment = bas.getExperiment();
	int maxRawMappings = bas.getMaxRawMappingsForSpot();
	IntensityTransform transform = bas.getIntensityTransform();
	
	List<TableColumn> formulas = new LinkedList<TableColumn>();
	DynamicUtil.addSpotColumns(formulas, dc, rdt.getChannels(), transform);
	DynamicUtil.addFormulaColumns(formulas, dc, rdt, Formula.Type.COLUMN_EXPRESSION, 
			transform, "", "", maxRawMappings == 1);
	DynamicUtil.addExtraColumns(formulas, dc, bas, "ev", "#", "[Xtra] ");
	if (maxRawMappings == 1)
	{
		DynamicUtil.addRawDataColumns(formulas, dc, rdt, "", "", "[Raw] ");
	}
	
	StringBuilder formulaOptions = new StringBuilder();
	for (TableColumn tc : formulas)
	{
		if (tc.getJepExpression() != null && tc.getDatatype().isNumerical())
		{
			String jepExpression = tc.getJepExpression();
			addFormulaOption(formulaOptions, jepExpression, tc.getTitle(), tc.getDescription());
		}
	}
	
	StringBuilder filterOptions = new StringBuilder();
	ItemQuery<Formula> formulaQuery = Formula.getQuery(Formula.Type.COLUMN_RESTRICTION, rdt, transform);
	formulaQuery.order(Orders.asc(Hql.property("name")));
	formulaQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	for (Formula formula : formulaQuery.list(dc))
	{
		String f = formula.getFormulas().get(0);
		if (maxRawMappings == 1 || !f.contains("raw("))
		{
			addFormulaOption(filterOptions, f, 
				formula.getName(), formula.getDescription());
		}
	}
	
	// Annnotations -- experimental factors and bioassay annotations
	final ItemQuery<AnnotationType> query = AnnotationType.getQuery(null);
	query.join(Hql.leftJoin("experiments", Item.EXPERIMENT.getAlias()));
	query.join(Hql.innerJoin("itemTypes", "itemType"));
	Restriction ef = Restrictions.eq(
		Hql.alias(Item.EXPERIMENT.getAlias()), 
		Hql.entity(experiment)
	);
	Restriction baa = Restrictions.eq(
		Hql.alias("itemType"),
		Expressions.integer(Item.BIOASSAY.getValue())
	);
	query.restrict(Restrictions.or(ef, baa));
	query.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	query.order(Orders.asc(Hql.property("name")));
	List<AnnotationType> experimentalFactors = query.list(dc);
	
	String title = HTML.encodeTags("Plot " + (ba == null ? bas.getName() : ba.getName()));
	
	final boolean hasCreateFilePermission = sc.hasPermission(Permission.CREATE, Item.FILE);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="~plotter.js" />
	<base:body>
	<h1><%=title%> <base:help helpid="plotter" /></h1>
	
	<div id="page-data" class="datacontainer"
		data-bioassayset="<%=bioAssaySetId %>"
		data-bioassay="<%=bioAssayId %>"
	></div>
	
	<form name="plot">
	<div class="content bottomborder">
		<div class="absolutefull rightborder" style="right: 550px;">
			<table class="fullform input100 smaller">
			<tbody>
				<tr>
					<th>Plot title</th>
					<td colspan="2"><input type="text" class="text" size="30" maxlength="255" name="title" 
						value="<%=HTML.encodeTags(ba == null ? bas.getName() : ba.getName())%>"></td>
				</tr>
				<tr>
					<th class="subprompt">Subtitle</th>
					<td colspan="2"><input type="text" class="text" maxlength="255" name="subTitle" 
						value=""></td>
				</tr>
				<tr>
					<th>Width</th>
					<td colspan="2"><input type="text" class="text" name="width" id="width"
						style="width: 10em;" maxlength="10" value="900"> (not used by preview)</td>
				</tr>
				<tr>
					<th>Height</th>
					<td colspan="2"><input type="text" class="text" name="height" id="height"
						style="width: 10em;" maxlength="10" value="600"></td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td colspan="2"></td>
				</tr>
			</tbody>
			<tbody class="sectionheader">
				<tr>
					<th>Plot type</th>
					<td colspan="2">
						<input type="radio" name="plotType" value="scatter" 
							id="plotTypeScatter" checked><label for="plotTypeScatter">Scatter</label>
						<input type="radio" name="plotType" value="histogram" 
							id="plotTypeHistogram"><label for="plotTypeHistogram">Histogram</label>
					</td>
				</tr>
			</tbody>
			<tbody id="scatterSection">
				<tr>
					<th>Y-axis</th>
					<td>
					<select name="yPresetsScatter" id="yPresetsScatter"
						class="auto-init"
						data-auto-init="formula-presets"
						data-formula-id="yFormulaScatter"
						data-label-id="yLabelScatter"
						style="width: 25em;"
						>
						<option value="">- select from list or enter formula below -
						<%=formulaOptions.toString()%>
					</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Expression</th>
					<td><input type="text" class="text required" maxlength="255" name="yFormulaScatter" id="yFormulaScatter"></td>
					<td>
						<base:icon
							id="btnExpressionBuilderYScatter"
							subclass="auto-init"
							data-auto-init="expression-builder"
							data-formula-id="yFormulaScatter"
							data-title="Y-axis expression"
							data-formula-type="COLUMN_EXPRESSION"
							data-raw-data-type="<%=rdt.getId() %>"
							data-channels="<%=rdt.getChannels() %>"
							data-bioassayset="<%=bioAssaySetId %>"
							image="expression_builder.png"
							tooltip="Use the Expression builder"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt">Y label</th>
					<td><input type="text" class="text" maxlength="255" name="yLabelScatter" id="yLabelScatter" value=""></td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt"><label for="yLogScatter">Log scale</label></th>
					<td><input type="checkbox" name="yLogScatter" id="yLogScatter" value="1"></td>
					<td></td>
				</tr>
				<tr>
					<th>X-axis</th>
					<td>
					<select name="xPresetsScatter" id="xPresetsScatter"
						class="auto-init"
						data-auto-init="formula-presets"
						data-formula-id="xFormulaScatter"
						data-label-id="xLabelScatter"
						style="width: 25em;"
						>
						<option value="">- select from list or enter formula below -
						<%=formulaOptions.toString()%>
					</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Expression</th>
					<td><input type="text" class="text required" maxlength="255" name="xFormulaScatter" id="xFormulaScatter"></td>
					<td>
						<base:icon
							id="btnExpressionBuilderXScatter"
							subclass="auto-init"
							data-auto-init="expression-builder"
							data-formula-id="xFormulaScatter"
							data-title="X-axis expression"
							data-formula-type="COLUMN_EXPRESSION"
							data-raw-data-type="<%=rdt.getId() %>"
							data-channels="<%=rdt.getChannels() %>"
							data-bioassayset="<%=bioAssaySetId %>"
							image="expression_builder.png"
							tooltip="Use the Expression builder"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt">X label</th>
					<td><input type="text" class="text" maxlength="255" name="xLabelScatter" id="xLabelScatter" value=""></td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt"><label for="xLogScatter">Log scale</label></th>
					<td><input type="checkbox" name="xLogScatter" id="xLogScatter" value="1"></td>
					<td></td>
				</tr>
			</tbody>
			
			<tbody id="histogramSection" style="display: none;">
				<tr>
					<th>Y-axis</th>
					<td>
						<input type="radio" name="yAggregate" id="yAggregateCount" value="count" checked 
							><label for="yAggregateCount">Count</label>
						<input type="radio" name="yAggregate" id="yAggregateMean" value="mean"
							><label for="yAggregateMean">Mean</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Hi-lo</th>
					<td>
						<input type="radio" name="hiloAggregate" id="hiloAggregateNone" value="" checked
							><label for="hiloAggregateNone">None</label>
						<input type="radio" name="hiloAggregate" id="hiloAggregateMinMax" value="hilomaxmin"
							><label for="hiloAggregateMinMax">Min/Max</label>
						<input type="radio" name="hiloAggregate" id="hiloAggregateStdev" value="hilostdev"
							><label for="hiloAggregateStdev">Stdev</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Presets</th>
					<td>
					<select name="yPresetsHistogram" id="yPresetsHistogram"
						class="auto-init"
						data-auto-init="formula-presets"
						data-formula-id="yFormulaHistogram"
						data-label-id="yLabelHistogram"
						style="width: 25em;"
						disabled
						>
						<option value="">- select from list or enter formula below -
						<%=formulaOptions.toString()%>
					</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Expression</th>
					<td><input type="text" class="text" maxlength="255" name="yFormulaHistogram" id="yFormulaHistogram" disabled></td>
					<td>
						<base:icon
							id="btnExpressionBuilderYHistogram"
							subclass="auto-init"
							data-auto-init="expression-builder"
							data-formula-id="yFormulaHistogram"
							data-title="Y-axis expression"
							data-formula-type="COLUMN_EXPRESSION"
							data-raw-data-type="<%=rdt.getId() %>"
							data-channels="<%=rdt.getChannels() %>"
							data-bioassayset="<%=bioAssaySetId %>"
							image="expression_builder.png"
							tooltip="Use the Expression builder"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt">Y label</th>
					<td><input type="text" class="text" maxlength="255" name="yLabelHistogram" id="yLabelHistogram" value="Count"></td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt"><label for="yLogHistogram">Log scale</label></th>
					<td><input type="checkbox" name="yLogHistogram" id="yLogHistogram" value="1"></td>
					<td></td>
				</tr>
				<tr>
					<th>X-axis</th>
					<td>
					<select name="xPresetsHistogram" id="xPresetsHistogram"
						class="auto-init"
						data-auto-init="formula-presets"
						data-formula-id="xFormulaHistogram"
						data-label-id="xLabelHistogram"
						style="width: 25em;"
						>
						<option value="">- select from list or enter formula below -
						<%=formulaOptions.toString()%>
					</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Expression</th>
					<td><input type="text" class="text required" maxlength="255" name="xFormulaHistogram" id="xFormulaHistogram"></td>
					<td>
						<base:icon
							id="btnExpressionBuilderXHistogram"
							subclass="auto-init"
							data-auto-init="expression-builder"
							data-formula-id="xFormulaHistogram"
							data-title="X-axis expression"
							data-formula-type="COLUMN_EXPRESSION"
							data-raw-data-type="<%=rdt.getId() %>"
							data-channels="<%=rdt.getChannels() %>"
							data-bioassayset="<%=bioAssaySetId %>"
							image="expression_builder.png"
							tooltip="Use the Expression builder"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt">X label</th>
					<td><input type="text" class="text" maxlength="255" name="xLabelHistogram" id="xLabelHistogram" value=""></td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt"><label for="xLogHistogram">Log scale</label></th>
					<td><input type="checkbox" name="xLogHistogram" id="xLogHistogram" value="1"></td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Bin size</th>
					<td><input type="text" class="text" name="binSize" value="1" style="width: 10em;"></td>
					<td></td>
				</tr>
			</tbody>
			<tbody>
				<tr>
					<th class="subprompt"></th>
					<td colspan="2"></td>
				</tr>
			</tbody>
			<tbody class="sectionheader">
				<tr>
					<th colspan="3">Filter &amp; annotations</th>
				</tr>
			</tbody>
			<tbody>
				<tr>
					<th>Filter</th>
					<td colspan="2">
						<select name="filterPresets" id="filterPresets"
							class="auto-init"
							data-auto-init="formula-presets"
							data-formula-id="filter"
							style="width: 25em;"
							>
							<option value="">- select from list or enter formula below -
							<%=filterOptions.toString()%>
						</select>
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td><input type="text" class="text" maxlength="255" name="filter" id="filter" placeholder="leave empty to plot all values"></td>
					<td>
						<base:icon
							id="btnExpressionBuilderFilter"
							subclass="auto-init"
							data-auto-init="expression-builder"
							data-formula-id="filter"
							data-title="Filter expression"
							data-formula-type="COLUMN_RESTRICTION"
							data-raw-data-type="<%=rdt.getId() %>"
							data-channels="<%=rdt.getChannels() %>"
							data-bioassayset="<%=bioAssaySetId %>"
							image="expression_builder.png"
							tooltip="Use the Expression builder"
						/>
					</td>
				</tr>
				<tr>
					<th>Annotation</th>
					<td colspan="2">
						<select name="annotationPresets" id="annotationPresets" style="width: 25em;">
							<option value="$">- none -
							<%
							if (ba == null)
							{
								%>
								<option value="$bioassay">Bioassay
								<option value="$spots">Spots
								<option value="$arrayDesign.name">Array design
								<option value="$software.name">Software
								<option value="$protocol.name">Protocol
								<option value="$scan.scanner.name">Scanner
								<option value="$scan.protocol.name">Scanning protocol
								<option value="$scan.hybridization.protocol.name">Hybridization protocol
								<option value="$scan.hybridization.creationEvent.eventDate">Hybridization date
								<option value="" disabled>- annotations -
								<%
								for (AnnotationType at : experimentalFactors)
								{
									%>
									<option value="$<%=at.getId()%>">[A] <%=HTML.encodeTags(at.getName())%>
									<%
								}
							}
							%>
							<option value="" disabled>- expressions -
							<%=filterOptions.toString()%>
							<option value="">Other...
						</select>
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td><input type="text" class="text" maxlength="255" name="annotationExp" id="annotationExp" disabled></td>
					<td>
						<base:icon
							id="btnExpressionBuilderAnnotation"
							subclass="auto-init"
							data-auto-init="expression-builder"
							data-formula-id="annotationExp"
							data-title="Annotation filter"
							data-formula-type="COLUMN_RESTRICTION"
							data-raw-data-type="<%=rdt.getId() %>"
							data-channels="<%=rdt.getChannels() %>"
							data-bioassayset="<%=bioAssaySetId %>"
							image="expression_builder.png"
							tooltip="Use the Expression builder"
						/>
					</td>
				</tr>
			</tbody>
			<tr class="dynamic">
				<th></th>
				<td colspan="2"></td>
			</tr>
			</table>
		</div>
		
		<div class="absolutefull filled" style="width: 550px; left: auto;">
				
					<img src="../../../images/plot_empty.png" id="preview" 
						style="position: absolute; top: 5px; z-index: 1;" alt="">
					<img src="../../../images/plot_select.png" id="overlay" 
						style="position: absolute; top: 5px; z-index: 2;" alt="">
		</div>
	</div>
	</form>
	
	<base:buttongroup subclass="dialogbuttons">
		<base:button 
			id="btnPreviewPlot"
			title="Preview"  
			image="plotter_preview.png" 
			tooltip="Generate a preview of the plot" 
		/>
		<base:button 
			id="btnViewPlot"
			title="View&hellip;"
			image="plotter.png" 
			tooltip="View a fullsized version of the plot (in a popup)" 
		/>
		<base:button 
			id="btnDownloadPlot"
			title="Download&hellip;"
			image="download.png"
			tooltip="Downlad a fullsized version of the plot to your computer" 
		/>
		<base:button 
			id="btnSavePlot"
			title="Save as&hellip;" 
			image="saveas.png"
			disabled="<%=!hasCreateFilePermission%>"
			tooltip="<%=hasCreateFilePermission ? 
				"Save a fullsized version of the plot on the BASE server" :
				"You don't have permission to create files" %>" 
		/>
		<base:button id="close" title="Close" />
	</base:buttongroup>
	
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
