/**
	$Id: AllowAnyHostNameVerifyer.java 5362 2010-06-16 12:28:36Z nicklas $

	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.ssl;

import java.io.IOException;
import java.security.cert.X509Certificate;

import javax.net.ssl.SSLException;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocket;

import net.sf.basedb.core.FileServer;

import org.apache.http.conn.ssl.X509HostnameVerifier;

/**
	A simple implementation of a host name verifyer that allows all hosts.
	We use it to make sure that a server certificate that has been registered
	with a {@link FileServer} always work even if the server has a different name
	than what is in the certificate.
	
	@author Nicklas
	@since 2.16
	@base.modified $Date: 2010-06-16 14:28:36 +0200 (on, 16 jun 2010) $
*/
public class AllowAnyHostNameVerifyer
	implements X509HostnameVerifier
{

	public AllowAnyHostNameVerifyer()
	{}

	@Override
	public void verify(String paramString, SSLSocket paramSSLSocket)
		throws IOException
	{}

	@Override
	public void verify(String paramString, X509Certificate paramX509Certificate)
		throws SSLException
	{}

	@Override
	public void verify(String paramString, String[] paramArrayOfString1,
			String[] paramArrayOfString2) throws SSLException
	{}

	@Override
	public boolean verify(String hostname, SSLSession session)
	{
		return true;
	}
}
